; *****************************************************************************
;
;                          SALIDA A PANTALLA
;
; *****************************************************************************

;
; Salida de una palabra en hexa (entrada en AX)
;
ConWord:push	ax
	mov	al,ah
	call	ConHex
	pop	ax
	call	ConHex
	ret
        
;
; Salida de un byte en hexa (entrada en AL)
;
ConHex:	push	ax			; save ax
	push	ax			; save for low byte
	shr	ax,4			; high byte
	call	ConHex2
	pop	ax			; low byte
	call	ConHex2
	pop	ax
	ret
ConHex2:push	ax
	and	ax,15			; print	NIBL in	hex
	cmp	ax,10
	jl	NotHexC
	add	ax,7
NotHexC:add	ax,'0'
	call	ConOut
	pop	ax
	ret

; Asume SI = offset del string
ConStr:
        push ax
        xor ah, ah
ConNext:
        mov al, byte ptr [si]
        inc si
        cmp ax, 0
        je ConStrSalida
        call ConOut
        jmp ConNext

ConStrSalida:
        pop ax
        ret
        

;
; Entrada de caracter en AL
;
ConIn:	push bx
	push cx
	push dx
        mov  ah,8                       ; lee caracter de consola (DOS)
        int  MSDOS                      ; ahora est en AL
        cmp  al,0                       ; es un char extendido ?
	jnz  CINotX
        mov  ah,8                       ; lee el prxima y setea el bit 7
	int  MSDOS
        or   al,080h                    ; setea el bit 7
CINotX:	pop  dx				;  dx, cx, bx
	pop  cx
	pop  bx
	ret
	
;
; Salida de caracter en AL
;
ConOut: push    ax
	push	bx
	push	cx
	push	dx
        
        cmp  al,0                       ; ignora NULL
	je   CXOut
	mov  dl,al
        cmp  dl,13                      ; cdigo especial para CT
	jne  NotCR
        mov  al,10                      ; escribe CR & LF
	Call ConOut
	mov  dl,13
NotCR:  mov  ah,6                       ; saoida a STDOUT
	int  MSDOS
CXOut:  
	pop	dx
	pop	cx
	pop	bx
	pop	ax
        ret

; *****************************************************************************
;
;                          INTERPRETE DE LINEA DE COMANDOS
;
; *****************************************************************************

LineaComandos:

	push	es

	mov	ax,psp
        mov     es,ax                   ; apuntamos a PSP para los parmetros

        mov     bp,081h                 ; bp apunto al command line
CLSkip: mov     al,es:[bp]              ; salteamos los espacios
	cmp	al,' '
	jne	CLSkip2
	inc	bp
	jmp	CLSkip
CLSkip2:mov     al,es:[bp]              ; vemos que m... es.
	cmp	al,13
        je      CLNoArchivo             ;   no se detect un archivo
	cmp	al,'-'
	je	Control

        mov     bx,bp                   ; lo hace un string tipo ASCIIZ
CLASCZ:	mov	al,es:[bx]
	inc	bx
	cmp	al,32
	jg	CLASCZ
	mov	es:byte	ptr -1[bx],0
        
	push	ds
	push	es
	pop	ds
        mov     dx,bp                   ; Abre el archio
	mov	al,0
	mov	ah,03Dh
	int	MSDOS
        jc      FallaCargax
	pop	ds
        push    ax                      ; Guarda el handle para el cierre

        mov     bx,ax                   ; Lee el archivo
	mov	dx,offset CartRom
        mov     cx,16384                ; Trata de leer 16k !!!
	mov	ah,03Fh
	int	MSDOS
        pop     bx                      ; Cierra el archivo
        push    ax                      ; ax = bytes ledos
	mov	ah,03Eh
	int	MSDOS
        jc      FallaCarga              ; carry = lectura fallda

	pop	ax
	push	ax
        cmp     ax,02000h               ; cartucho de 8k ???
        je      Modo8k
	cmp	ax,04000h
        je      Modo16k

        cmp     ax,0800h                ; lectura en archivo de 2k ???
        jne     CCret                   ;   no, terminamos.

        mov     bx,07FEh                ; copia los 2k inferiores en los 2k superiores
CopiaCartucho:
	mov	ax,word	ptr CartRom[bx]
	mov	word ptr CartRom+0800h[bx],ax
	sub	bx,2
        jge     CopiaCartucho
CCret:	jmp	Conret

CLNoArchivo:
        jmp     CLDoNoArchivo

Modo8k:                                 ; Setea direccionamiento de 8k
	mov	[ReadBank], offset RBank8
	mov	[WriteBank], offset WBank8
	jmp	Conret
Modo16k:                                ; Setea direccionamiento de 16k
	mov	[ReadBank], offset RBank16
	mov	[WriteBank], offset WBank16
	jmp	Conret
        
Conret: pop     cx                      ; tamao del cartucho
	pop	es
        ret

; *
; * primero procesa lo requerimientos para lneas de comienzo especiales
; *

FallaCargax:
	pop	ds
FallaCarga:
	pop	es
	mov	al,7
	jmp	ConOut

Control:mov     cl,es:1[bp]             ; obtiene letra de control
	cmp	cl,'A'
	jl	CNext
	cmp	cl,'Z'
	jg	CNext
	add	cl,32
CNext:	add	bp,2
	mov	al,0
GetInt:	mov	ah,es:[bp]
	inc	bp
	cmp	ah,'0'
	jl	EndInt
	cmp	ah,'9'
	jg	EndInt
        mov     bl,al                   ; AL = AL * 10
	shl	al,2
	add	al,bl
	add	al,al
	add	al,ah
	sub	al,'0'
	jmp	GetInt

EndInt:                                 ; El comando est en CL, valor en AL
	cmp	cl,'u'
	je	CMUpper
	cmp	cl,'l'
	je	CMLower
	cmp	cl,'0'
	je	CMD0
	cmp	cl,'1'
	je	CMD1
	cmp	cl,'b'
	je	CMBW
	cmp	cl,'r'
        je      CMSinRetrace
	cmp	cl,'t'
	je	CMTimer1
        jmp     CLSkip                  ; vuelve al comienzo

CMUpper:xor     ah,ah                   ; configura la primera lnea de barrido
	mov	[CFirst],ax
	jmp	CLSkip
CMLower:xor     ah,ah                   ; configura la ltima lnea de barrido
	mov	[CLast],ax
	jmp	CLSkip

CMD0:   mov     al,[IOPortB]            ; p0 difcil
	or	al,64
	mov	[IOPortB],al
	jmp	CLSkip

CMD1:   mov     al,[IOPortB]            ; p1 difcil
	or	al,128
	mov	[IOPortB],al
	jmp	CLSkip

CMBW:   mov     al,[IOPortB]            ; blanco y negro
	and	al,0C3h
	mov	[IOPortB],al
	jmp	CLSkip

CMSinRetrace:
        mov     [SinRetrace],1         ; no espera por el retrace (mx. vel.)
	jmp	CLSkip

CMTimer1:
	mov	[TimerVec],offset Timer1 ; force Timer1
	jmp	CLSkip

; No aparece el nombre de archivo

CLDoNoArchivo:
	pop	es
	mov	dx,offset CopyRight
	mov	ah,9
        int     MSDOS                   ; muestra el mensaje
	mov	dx,offset Cred0
	mov	ah,9
	int	MSDOS
	mov	dx,offset Cred1
	mov	ah,9
	int	MSDOS
	mov	dx,offset Cred2
	mov	ah,9
	int	MSDOS
        mov     dx,offset Msj0
	mov	ah,9
        int     MSDOS                   ; muestra el mensaje
        mov     dx,offset Msj1
	mov	ah,9
        int     MSDOS                   ; muestra el mensaje
        mov     dx,offset Msj2
	mov	ah,9
        int     MSDOS                   ; muestra el mensaje
        mov     dx,offset Msj3
	mov	ah,9
        int     MSDOS                   ; muestra el mensaje
        mov     dx,offset Msj4
	mov	ah,9
        int     MSDOS                   ; muestra el mensaje
        mov     dx,offset Msj5
	mov	ah,9
        int     MSDOS                   ; muestra el mensaje
        mov     dx,offset Msj6
	mov	ah,9
        int     MSDOS                   ; muestra el mensaje
        mov     dx,offset Msj7
	mov	ah,9
	int	MSDOS
        mov     dx,offset Msj8
	mov	ah,9
        int     MSDOS                   ; muestra el mensaje
        mov     dx,offset Msj9
	mov	ah,9
        int     MSDOS                   ; muestra el mensaje
        mov     dx,offset Msj10
	mov	ah,9
        int     MSDOS                   ; muestra el mensaje
        mov     dx,offset Msj11
	mov	ah,9
        int     MSDOS                   ; muestra el mensaje
        jmp     Vacio                   ;   sale

.CEND
.DATASEGMENT

CopyRight       db      13,10,'PLM -- Un Emulador de Atari 2600 (v0.1)',13,10,10,'$'
Cred0           db      'Realizado por Fabin Winternitz        (fwinter@dc.uba.ar)',13,10,'$'
Cred1           db      '              Alejandro Isacovich      (aleisa@dc.uba.ar)',13,10,'$'
Cred2           db      '              Ernesto Mislej           (emislej@dc.uba.ar)',13,10,10,'$'
Msj0            db      '    F1 -- reset    ','$'
Msj1            db      '    F2 -- seleccin',13,10,'$'
Msj2            db      '    F9 -- B/W      ','$'
Msj3            db      '   F10 -- color',13,10,'$'
Msj4            db      '     p -- pausa    ','$'
Msj5            db      ' ENTER -- continuar',13,10,'$'
Msj6            db      ' SPACE -- disparo  ','$'
Msj7            db      '   ESC -- salir del juego',13,10,10,'$'

Msj8            db      'Switches (antes del nombre de archivo)',13,10,10,'$'

Msj9            db      '    -0 -- dificultad para jugador 0',13,10,'$'
Msj10           db      '    -r -- no espera el VGA retrace (mxima velocidad)',13,10,10,'$'

Msj11           db      'El joystick es emulado con las teclas de flecha.',13,10,10,'$'

.DEND
.CODESEGMENT
