;******************************************************************************
; PLM -- Emulador de Atari v1.0
; Realizado por Fabin Winternitz   (fwinter@dc.uba.ar)
;               Alejandro Isacovich (aleisa@dc.uba.ar)
;               Ernesto Mislej      (emislej@dc.uba.ar)
;
PAGE 66,132
;
; definiciones en tiempo de ensamblado
;

memcheats =  1                          ; truco para lecturas de 16-bit

MSDOS =                 021H            ; llamada a MSDOS

CiclosPorLineaBarrido = 76              ; constantes de timing del TIA


;offset de los registros TIA

TIANuSiz0 =             04h             ; controles de tamao de Misil/Jugador
TIANuSiz1 = 		05h
TIAColup0 = 		06h
TIAColup1 = 		07h
TIAColupf = 		08h
TIAColubk = 		09h
TIACtrlPf =             0Ah             ; control del campo de juego, prioridad, tamao de la bocha
TIARefP0 =              0Bh             ; refleccin del juegador
TIARefP1 =              0Ch             ; refleccin del juegador
TIAPf0 =                0Dh             ; registros del campo de juego
TIAPf1 = 		0Eh
TIAPf2 = 		0Fh
TIAResp0 =              10h             ; Registros de reset de posicin Horizonal
TIAResp1 = 		11h
TIAResm0 = 		12h
TIAResm1 = 		13h
TIAResbl = 		14h
TIAGrp0 =               1Bh             ; Grfico jugador 0
TIAGrp1 =               1Ch             ; Grfico Jugador 1
TIAEnam0 =              1Dh             ; Habilitacin Misil 0
TIAEnam1 =              1Eh             ; Habilitacin Misil 1
TIAEnabl =              1Fh             ; Habilitacin Bola
TIAHmp0	= 		20h
TIAHmp1	= 		21h
TIAHmm0	= 		22h
TIAHmm1	= 		23h
TIAHmbl	= 		24h
TIAVDelp0 = 		25h
TIAVDelp1 = 		26h
TIAVDelbl =             27h             ; Habilitacin espera vertical de la bola
TIAResmp0 =             28h             ; Misil bloqueado al jugador
TIAResmp1 = 		29h


; Buffer de informacin del TIA. Cada registro contiene 4 byte:
;
;       0 - Clock grfico cuando es escrito (TIAFin = fin del buffer)
;       1 - Registro siendo escrito
;       2 - Valor siendo escrito
;       3 - <reservado>

TIAClock =              0               ; Estas deben tener estos valores
TIAReg   =              2               ; ... y en este orden
TIAVal   =              3               ; (quin sabe porque?)

TIAFin  =               255             ; marca de fin de buffer
TIAInvalido=            254             ; entrada invlida


; Definiciones de bit de una lnea grfica del TIA. En un byte del TIADisplay
; se encienden los bits correspondientes, dependiendo de todos los objetos
; que deban ser encendidos en ese byte. Varios bits encendidos indica que ms
; de un objeto se encuentra en la misma posicin

TGPlay =                1               ; Bit de campo de juego
TGBall =                2               ; Bit de bola
TGPlayer1 =             4               ; Bit de P1 (jugador 1)
TGMissile1 =            8               ; Bit de M1 (misil 1)
TGPlayer0 =             16              ; Bit de P0 (jugador 0)
TGMissile0 =            32              ; Bit de M0 (misil 0)
TGCollisionReset =      128             ; Bit para reseteo de colisin


; posiciones dentro de TIAColourTable

TCTPF =                 1               ; campo de juego
TCTBK =                 0               ; fondo
TCTP0 =                 3               ; jugador 0
TCTP1 =                 2               ; jugador 1

        include macrovga.asm            ; nuestras macros
        include macrocpu.asm            ; macros relacionados con la cpu
        include macromat.asm            ; macros para aritmtica

;
; Stack segment para archivos .EXE
;
Stack SEGMENT PARA STACK 'STACK'
	DB 512 DUP (?)
Stack ENDS

.386                                    ; Permite instrucciones de 32 bits

.CODESEGMENT
.CEND

.DATASEGMENT
        include tablas.asm
.DEND


.CODESEGMENT

entrada: jmp     comienzo               ; Salta a nuestra entrada del programa
	
        include entrada.asm             ; Salida a pantalla e
                                        ;    Intrprete de lnea de comandos
        include teclado.asm             ; Convierte el teclado en el joystick de Atari
        include vga.asm                 ; Inicializacin de grficos de VGA
        include 6507.asm                ; Rutinas de soporte y cdigo de operacin del 6502
        include pia_tia.asm             ; empieza ac. Emula TIA y PIA

.CEND




        END     entrada
