; La mayor parte de los datos estn aca. Tratamos de dejar todo en un mismo
; lugar, lejos del cdigo. Corre ms rpido de esta forma (algo relacionado
; con la coherencia de cache).

; *****************************************************************************
;                      Set de Registros del 6502 (alamacenamiento)
;        duante la emulacin estas posiciones no contiene datos correctos!
; *****************************************************************************

RPC             dw      0               ; program counter (va en BP)
RA              db      0               ; acumulador (va en AL)
RCarry          db      0               ; bit de carry (va en AH)
RS              db      0               ; stack pointer (va en CL)

; *****************************************************************************
;                Estos flags son actualizados durante la emulacin
;     Z y N son tratados desde los valores almacenados en RZTEST y RNTEST
; *****************************************************************************

RClock          db      0               ; ciclos de clock (alamcenado en SI)
RCycles         db      0               ; ciclos para esta instruccin

ALIGN 2

RX              db      0               ; registro X (alamcenado en DL)
                db      0               ; para permitir load & store de 16 bits (ver _index)
RY              db      0               ; registro Y (alamcenado en DH)
                db      0               ; para permitir load & store de 16 bits (ver _index)
RZTest          db      0               ; valor para el test de Zero (Z enciende cuando hay 0)
RNTest          db      0               ; valor para el test de signo (N enciende cuando hay negativo)
FDec            db      0               ; flag decimal
FOver           db      0               ; flag de overflow
FIntDis         db      0               ; flag de deshabilitacin de interrupcin
FBreak          db      0               ; flag de Break


; *****************************************************************************
;				Riot Timer
; *****************************************************************************

ALIGN 2

Timer           dw      0               ; RIOT Timer
TickCnt         dw      0               ; nmero de ticks hasta que el timer hace click
TRate           dw      0               ; nmero de ciclos por click del timer

; *****************************************************************************
;                             Otras cosas
; *****************************************************************************

LineaBarrido        dw      0               ; barrido de lnea actual
Frame           dw      0               ; contador de Frames
FrameAnterior   dw      0               ; valor previo del contador de Frames
VBlank          db      0               ; flag de VBlank (borrado vertical)

FEnd=$

ALIGN 2

TimerVec        dw      Timer0          ; vector de rutinas de tiempo
LineaSup        dw      0               ; era 36     lnea superior del display
LineaInf        dw      0               ; era 36+200 lnea inferior del display
CFirst          dw      8
CLast           dw      256
MaxLineas       dw      200             ; mx # de lneas para barrer
DisplayPointer  dw      0               ; puntero a la memoria de display
DisplayTranslate dw offset TIADisplayToColour ; tabla de traduccin display a color

SinRetrace      db      0               ; no espera por VGA retrace (si es 1)
JuegoPausado    db      0               ; juego pausado ?
NoScoreMode     db      0               ; encendido si no se quiere que se use el color de jugadores en PF
CiclosPorLinea  db      CiclosPorLineaBarrido-2 ; # de ciclos para ejecutar instrucciones en cada lnea
VBlankFrame     db      0               ; VBlank causa un nuevo frame
UltimoCiclo     db      0               ; para HaceInstrucciones

ReadBank        dw      RBank4          ; funcin de cambio de banco (lectura)
WriteBank       dw      WBank4          ; funcion de cambio de banco (escritura)
        
RomBank		dw	0

SubVector       dw      DoSbc           ; vectores para suma y resta
AddVector	dw	DoAdc

CtrlFn          dw      Controls        ; vector de Control (paddles/sticks)

psp             dw      0               ; toma el puntero a PSP (si es un archivo .EXE)

Ret00		db	0
Ret0F		db	0Fh
Ret80		db	80h
RetFF		db	0FFh

TimerCount      dw      8,64,1024       ; valores de cuenta para el RIOT

RetWd           db      0               ; byte devuelto en lecutra de colisin

WByte           db      0               ; byte a ser escrito



; procesa estos comenados inmediatamente

ALIGN 2

WrTiaImmediateVector	dw	WrTiaVSync	; 0
			dw	WrTiaVBlank	; 1
			dw	WrTiaWSync	; 2
                        dw      WSret           ; 3 -- reseta sincronismo horizontal
                                                ;      para prueba de fabrica solamente !
		        

IOPortB         db      00Bh            ; puerto de E/S B (switches)
IOPortA         db      0FFh            ; puerto de E/S A (joystick)

DumpPorts       db      0,0,0,0         ; puertos de entrada (inp0..3)

InputLatch      db      080h            ; latch de entrada (inp4)
                db      080h            ; latch de entrada (inp5)
	   

ALIGN 2

OldInt9         dw      0,0             ; puntero al int9 original

TablaTecla      db      128 dup (0)     ; tabla de teclas apretadas

TIABuffer       db 128 dup (TIAFin)     ; buffer de informacin del TIA

TIA             db 64 dup (0)           ; registros del TIA

VDP0Gr          db   0                  ; buffer para el grfico Vertical Delay del Jugador 0
VDP1Gr          db   0                  ; buffer para el grfico Vertical Delay del Jugador 1
VDBlEn          db   0                  ; buffer para el Vertical Delay de la bocha cuando est habilitada


ALIGN 4

TIADisplay      db 320 dup (0)          ; vector que contiene los objetos que deben escribirse en cada pixel.
TIALineaBarrido dw      0               ; lnea de Barrido
TIAWritePointer dw      0               ; puntero al buffer de escritura del TIA
TIAFrameSkip    dw      -1              ; vale cero si el frame es salteado
TIACollide      dw      0               ; palabra para el flag de colisin (hace falta 15 bits)

ALIGN 4


; Tabla de posicin de los ciclos. Permite hacer que cada registro sea ledo
; cada un perodo detemindo. Por ejemplo, en el caso de los RESPx, los mismos
; pueden ser ledos por el TIA cada 5 ciclos de procesador. Luego, cuando
; el evento es ingresado en el TIABuffer, es desplazado tantos ciclos como
; sea necesario para mantener la emulacin coherente.

CO=-1
C1=-2
C2=-2

CycleOffset	db	68+CO	;00	VSYNC
		db	68+CO	;01	VBLANK
		db	68+CO	;02	WSYNC
		db	68+CO	;03	RSYNC
		db	68+CO	;04	NUSIZ0
		db	68+CO	;05	NUSIZ1
		db	68+C2	;06	COLUP0
		db	68+C2	;07	COLUP1
		db	68+C2	;08	COLUPF
		db	68+C2	;09	COLUBK
		db	68+C2	;0a	CTRLPF
		db	68+CO	;0b	REFP0
		db	68+CO	;0c	REFP1
		db	68+C1	;0d	PF0
		db	68+C1	;0e	PF1
		db	68+C1	;0f	PF2
                db      68-5    ;10     RESP0
                db      68-5    ;11     RESP1
                db      68-4    ;12     RESM0
                db      68-4    ;13     RESM1
                db      68-4    ;14     RESBL
                db      68+CO   ;15     AUDC0
                db      68+CO   ;16     AUDC1
                db      68+CO   ;17     AUDF0
                db      68+CO   ;18     AUDF1
                db      68+CO   ;19     AUDV0
		db	68+CO	;1a	AUDV1
		db	68+CO	;1b	GRP0
		db	68+CO	;1c	GRP1
		db	68+CO	;1d	ENAM0
		db	68+CO	;1e	ENAM1
		db	68+CO	;1f	ENABL
		db	68+CO	;20	HMP0
		db	68+CO	;21	HMP1
		db	68+CO	;22	HMM0
		db	68+CO	;23	HMM1
		db	68+CO	;24	HMBL
		db	68+CO	;25	VDELP0
		db	68+CO	;26	VDEL01
		db	68+CO	;27	VDELBL
		db	68+CO	;28	RESMP0
		db	68+CO	;29	RESMP1
		db	68+CO	;2a	HMOVE
		db	68+CO	;2b	HMCLR
		db	68+CO	;2c	CXCLR

        

ALIGN 4

; tabla para saber que bit hay que verificar segn el contador del campo
; de juego. Se cuenta de 0 a 23 y en cada paso se consulta la tabla para saber
; el orden de los bits reales a verificar en la emulacin

;	  PF2		|	  PF1		|	  PF0		|
; 7  6	5  4  3	 2  1  0  7  6	5  4  3	 2  1  0  7  6	5  4  3	 2  1  0
;23 22 21 20 19 18 17 16 15 14 13 12 11 10  9  8  7  6	5  4  3	 2  1  0
;				  ECX					|

PfClockToBitTable       dd      1 shl 4         ;0      hacia adelante
			dd	1 shl 5		;1
			dd	1 shl 6		;2
			dd	1 shl 7		;3
			dd	1 shl 15	;4
			dd	1 shl 14	;5
			dd	1 shl 13	;6
			dd	1 shl 12	;7
			dd	1 shl 11	;8
			dd	1 shl 10	;9
			dd	1 shl 9		;10
			dd	1 shl 8		;11
			dd	1 shl 16	;12
			dd	1 shl 17	;13
			dd	1 shl 18	;14



			dd	1 shl 19	;15
			dd	1 shl 20	;16
			dd	1 shl 21	;17
			dd	1 shl 22	;18
			dd	1 shl 23	;19
		        
                        dd      1 shl 23        ;20     campo de juego invertido
			dd	1 shl 22	;21
			dd	1 shl 21	;22
			dd	1 shl 20	;23
			dd	1 shl 19	;24
			dd	1 shl 18	;25
			dd	1 shl 17	;26
			dd	1 shl 16	;27
			dd	1 shl 8		;28
			dd	1 shl 9		;29
			dd	1 shl 10	;30
			dd	1 shl 11	;31
			dd	1 shl 12	;32
			dd	1 shl 13	;33
			dd	1 shl 14	;34
			dd	1 shl 15	;35
			dd	1 shl 7		;36
			dd	1 shl 6		;37
			dd	1 shl 5		;38
			dd	1 shl 4		;39


TGODiffTab	dw	TGORet		; 0
		dw	TGO2Close	; 1
		dw	TGO2Medium	; 2
		dw	TGO3Close	; 3
		dw	TGO2Far		; 4
		dw	TGO2Width	; 5
		dw	TGO3Medium	; 6
		dw	TGO4Width	; 7



;
; Byte del TIADisplay a palabra de colisin
;
;
                        ;      Valor   Registro       Valor
                        ; Reg  Hexa    Binario        Binario

TIAColTab dw 0          ;  0   0000 -  0000 0000 -
   dw 0                 ;  1   0000 -  0000 0001 -
   dw 0                 ;  2   0000 -  0000 0010 -
   dw 8192              ;  3   2000 -  0000 0011 - 0010 0000 0000 0000
   dw 0                 ;  4   0000 -  0000 0100 -
   dw 128               ;  5   0080 -  0000 0101 - 0000 0000 1000 0000
   dw 64                ;  6   0040 -  0000 0110 - 0000 0000 0100 0000
   dw 8384              ;  7   20C0 -  0000 0111 - 0010 0000 1100 0000
   dw 0                 ;  8   0000 -  0000 1000 -
   dw 2048              ;  9   0800 -  0000 1001 - 0000 1000 0000 0000
   dw 1024              ;  10  0400 -  0000 1010 - 0000 0100 0000 0000
   dw 11264             ;  11  2C00 -  0000 1011 - 0010 1100 0000 0000
   dw 4                 ;  12  0004 -  0000 1100 - 0000 0000 0000 0100
   dw 2180              ;  13  0884 -  0000 1101 - 0000 1000 1000 0100
   dw 1092              ;  14  0444 -  0000 1110 - 0000 0100 0100 0100
   dw 11460             ;  15  2CC4 -  0000 1111 - 0010 1100 1100 0100
   dw 0                 ;  16  0000 -  0001 0000 -
   dw 32                ;  17  0020 -  0001 0001 - 0000 0000 0010 0000
   dw 16                ;  18  0010 -  0001 0010 - 0000 0000 0001 0000
   dw 8240              ;  19  2030 -  0001 0011 - 0010 0000 0011 0000
   dw 32768             ;  20  8000 -  0001 0100 - 1000 0000 0000 0000
   dw 32928             ;  21  80A0 -  0001 0101 - 1000 0000 1010 0000
   dw 32848             ;  22  8050 -  0001 0110 - 1000 0000 0101 0000
   dw 41200             ;  23  A0F0 -  0001 0111 - 1010 0000 1111 0000
   dw 8                 ;  24  0008 -  0001 1000 - 0000 0000 0000 1000
   dw 2088              ;  25  0828 -  0001 1001 - 0000 1000 0010 1000
   dw 1048              ;  26  0418 -  0001 1010 - 0000 0100 0001 1000
   dw 11320             ;  27  2C38 -  0001 1011 - 0010 1100 0011 1000
   dw 32780             ;  28  800C -  0001 1100 - 1000 0000 0000 1100
   dw 34988             ;  29  88AC -  0001 1101 - 1000 1000 1010 1100
   dw 33884             ;  30  845C -  0001 1110 - 1000 0100 0101 1100
   dw 44284             ;  31  ACFC -  0001 1111 - 1010 1100 1111 1100
   dw 0                 ;  32  0000 -  0010 0000 -
   dw 512               ;  33  0200 -  0010 0001 - 0000 0010 0000 0000
   dw 256               ;  34  0100 -  0010 0010 - 0001 0000 0000 0000
   dw 8960              ;  35  2300 -  0010 0011 - 0010 0011 0000 0000
   dw 2                 ;  36  0002 -  0010 0100 - 0000 0000 0000 0010
   dw 642               ;  37  0282 -  0010 0101 - 0000 0010 1000 0010
   dw 322               ;  38  0142 -  0010 0110 - 0000 0001 0100 0010
   dw 9154              ;  39  23C2 -  0010 0111 - 0010 0011 1100 0010
   dw 16384             ;  40  4000 -  0010 1000 - 0100 0000 0000 0000
   dw 18944             ;  41  4A00 -  0010 1001 - 0100 1010 0000 0000
   dw 17664             ;  42  4500 -  0010 1010 - 0100 0101 0000 0000
   dw 28416             ;  43  6F00 -  0010 1011 - 0110 1111 0000 0000
   dw 16390             ;  44  4006 -  0010 1100 - 0100 0000 0000 0110
   dw 19078             ;  45  4A86 -  0010 1101 - 0100 1010 1000 0110
   dw 17734             ;  46  4546 -  0010 1110 - 0100 0110 0100 0110
   dw 28614             ;  47  6FC6 -  0010 1111 - 0110 1111 1100 0110
   dw 1                 ;  48  0001 -  0011 0000 - 0000 0000 0000 0001
   dw 545               ;  49  0221 -  0011 0001 - 0000 0010 0010 0001
   dw 273               ;  50  0111 -  0011 0010 - 0000 0001 0001 0001
   dw 9009              ;  51  2331 -  0011 0011 - 0010 0011 0011 0001
   dw 32771             ;  52  8003 -  0011 0100 - 1000 0000 0000 0011
   dw 33443             ;  53  82A3 -  0011 0101 - 1000 0010 1010 0011
   dw 33107             ;  54  8153 -  0011 0110 - 1000 0001 0101 0011
   dw 41971             ;  55  A3F3 -  0011 0111 - 1010 0011 1111 0011
   dw 16393             ;  56  4009 -  0011 1000 - 0100 0000 0000 1001
   dw 18985             ;  57  4A29 -  0011 1001 - 0100 1010 0010 1001
   dw 17689             ;  58  4519 -  0011 1010 - 0100 0101 0001 1001
   dw 28473             ;  59  6F39 -  0011 1011 - 0110 1111 0011 1001
   dw 49167             ;  60  C00F -  0011 1100 - 1100 0000 0000 1111
   dw 51887             ;  61  CAAF -  0011 1101 - 1100 1010 1010 1111
   dw 50527             ;  62  C55F -  0011 1110 - 1100 0101 0101 1111
   dw 61439             ;  63  EFFF -  0011 1111 - 1110 1111 1111 1111


; *****
; Los valores de estas tablas indcan el color de qu objeto se debe utilizar
; para escribir el pixel. Hay unas 3Fh posiciones, las cuales son todas las
; posibilidades que hay de agruparlos en un byte del TIADisplay. Cada bit
; del TIADisplay hace referencia a qu objeto est presente en el pixel.
; *****

TIADisplayToColour db 0,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2
 db 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3
 db 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3
 db 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3


; Esta tabla se utiliza de la misma forma que la anterior, pero se utiliza
; cuando el bit de prioridad del campo de juego es diferente

TIADisplayToColour2 db 0,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1
 db 3,1,1,1,3,1,1,1,3,1,1,1,3,1,1,1
 db 3,1,1,1,3,1,1,1,3,1,1,1,3,1,1,1
 db 3,1,1,1,3,1,1,1,3,1,1,1,3,1,1,1


; Esta tabla contiene el color que se debe utilizar en el momento de accederla
; para cada uno de los objetos.

TIAColourTable  db      TIAColubk       ; Fondo
                db      TIAColupf       ; Campo de Juego
                db      TIAColup1       ; Jugador 1, Misil 1
                db      TIAColup0       ; Jugador 0, Misil 0

ALIGN 2

; Vector de cdigos de operacin para el 6507

vectors dw op00,op01,fail,fail,fail,op05,op06,fail
	dw op08,op09,op0a,fail,fail,op0d,op0e,fail
	dw op10,op11,fail,fail,fail,op15,op16,fail
	dw op18,op19,fail,fail,fail,op1d,op1e,fail

	dw op20,op21,fail,fail,op24,op25,op26,fail
	dw op28,op29,op2a,fail,op2c,op2d,op2e,fail
	dw op30,op31,fail,fail,fail,op35,op36,fail
	dw op38,op39,fail,fail,fail,op3d,op3e,fail

	dw op40,op41,fail,fail,fail,op45,op46,fail
	dw op48,op49,op4a,fail,op4c,op4d,op4e,fail
	dw op50,op51,fail,fail,fail,op55,op56,fail
	dw op58,op59,fail,fail,fail,op5d,op5e,fail

	dw op60,op61,fail,fail,fail,op65,op66,fail
	dw op68,op69,op6a,fail,op6c,op6d,op6e,fail
	dw op70,op71,fail,fail,fail,op75,op76,fail
	dw op78,op79,fail,fail,fail,op7d,op7e,fail

	dw fail,op81,fail,fail,op84,op85,op86,fail
	dw op88,fail,op8a,fail,op8c,op8d,op8e,fail
	dw op90,op91,fail,fail,op94,op95,op96,fail
	dw op98,op99,op9a,fail,fail,op9d,fail,fail

	dw opa0,opa1,opa2,fail,opa4,opa5,opa6,fail
	dw opa8,opa9,opaa,fail,opac,opad,opae,fail
	dw opb0,opb1,fail,fail,opb4,opb5,opb6,fail
	dw opb8,opb9,opba,fail,opbc,opbd,opbe,fail

	dw opc0,opc1,fail,fail,opc4,opc5,opc6,fail
	dw opc8,opc9,opca,fail,opcc,opcd,opce,fail
	dw opd0,opd1,fail,fail,fail,opd5,opd6,fail
	dw opd8,opd9,fail,fail,fail,opdd,opde,fail

	dw ope0,ope1,fail,fail,ope4,ope5,ope6,fail
	dw ope8,ope9,opea,fail,opec,oped,opee,fail
	dw opf0,opf1,fail,fail,fail,opf5,opf6,fail
	dw opf8,opf9,fail,fail,fail,opfd,opfe,fail


; *****************************************************************************
;                           Ciclos por Instruccin
; *****************************************************************************
;	      0	 1  2  3  4  5	6  7  8	 9  a  b  c  d	e  f
Cycles	db    7, 6, 2, 8, 3, 3, 5, 5, 3, 2, 2, 2, 4, 4, 6, 6  ; 0
	db    2, 5, 2, 8, 4, 4, 6, 6, 2, 4, 2, 7, 4, 4, 7, 7  ; 1
	db    6, 6, 2, 8, 3, 3, 5, 5, 4, 2, 2, 2, 4, 4, 6, 6  ; 2
	db    2, 5, 2, 8, 4, 4, 6, 6, 2, 4, 2, 7, 4, 4, 7, 7  ; 3
	db    6, 6, 2, 8, 3, 3, 7, 5, 3, 2, 2, 2, 3, 4, 6, 6  ; 4
	db    2, 5, 2, 8, 4, 4, 6, 6, 2, 4, 2, 7, 4, 4, 7, 7  ; 5
	db    6, 6, 2, 8, 3, 3, 5, 5, 4, 2, 2, 2, 5, 4, 6, 6  ; 6
	db    2, 5, 2, 8, 4, 4, 6, 6, 2, 4, 2, 7, 4, 4, 7, 7  ; 7
	db    2, 6, 2, 6, 3, 3, 3, 3, 2, 2, 2, 2, 4, 4, 4, 4  ; 8
	db    2, 6, 2, 6, 4, 4, 4, 4, 2, 5, 2, 5, 5, 5, 5, 5  ; 9
	db    2, 6, 2, 6, 3, 3, 3, 3, 2, 2, 2, 2, 4, 4, 4, 4  ; a
	db    2, 5, 2, 5, 4, 4, 4, 4, 2, 4, 2, 4, 4, 4, 4, 4  ; b
	db    2, 6, 2, 8, 3, 3, 5, 5, 2, 2, 2, 2, 4, 4, 6, 6  ; c
	db    2, 5, 2, 8, 4, 4, 6, 6, 2, 4, 2, 7, 4, 4, 7, 7  ; d
	db    2, 6, 2, 8, 3, 3, 5, 5, 2, 2, 2, 2, 4, 4, 6, 6  ; e
	db    2, 5, 2, 8, 4, 4, 6, 6, 2, 4, 2, 7, 4, 4, 7, 7  ; f

; Espacio de memoria

RiotRam         db 128 dup (0)          ; memoria del RIOT


ALIGN 4

CartRom         db 0a5h                 ; ROM del cartucho predefinido (colour.bin)
 db 081h,085h,00fh,0a9h,003h,085h,00ah,0a9h,057h,085h,007h,0a0h,000h,088h,085h,002h,085h,001h,085h,000h,0a9h,02ah,08dh,095h,002h,0ach,084h,002h,0d0h,0fbh,084h
 db 002h,084h,000h,0a9h,024h,08dh,096h,002h,0adh,082h,002h,029h,001h,0d0h,001h,000h,0e6h,080h,0d0h,00ah,0a9h,0e0h,085h,080h,0e6h,081h,0a5h,081h,085h,006h,0ach,084h
 db 002h,0d0h,0fbh,084h,002h,084h,001h,0a2h,0e4h,084h,002h,086h,00eh,086h,007h,0cah,0d0h,0f7h,04ch,000h,0f0h,0e0h,085h,080h,0e6h,081h,0a5h,081h,085h,006h,0ach,084h
 
ALIGN 4

                db      16384 dup (0)   ; reserva espacio para el cartucho
                db      1024 dup (0)    ; reserva espacio para el stack
mystack         db      0               ; tope del stack
