; *****************************************************************************
;
;                           CAMBIA A MODO GRAFICO
;
; *****************************************************************************

TIAModoGrafico:

;*
;* genera la paleta
;*
;*     acutalmente se hace una interpolacin lineal entre el brillo y los
;*     registros de 3 elementos del RGB para obtner los otros 6 valores LUM
;*     (luminosidad).
;*

GeneraPaleta:
        mov     si,offset TablaPaletaDefault
	mov	di,offset PCXPalette
        mov     [CuentaPaleta],0        ; hace 16 colores
PaletaLoop:                             ; <-- por cada color
        mov     cx,0                    ; inicializa 8 valores de LUM
BrilloLoop:
        mov     dx,3                    ; hace 3 valores de RGB
RGBLoop:
	mov	al,3[si]		; [RHi]
	mov	bl,0[si]		; [RLo]
	sub	al,bl			; al = RHi - RLo
	mov	bl,7
	div	bl			; al = (RHi - RLo) / 7
	mul	cl			; al = cl * (RHi - RLo) / 7
	mov	bl,0[si]		; [RLo]
        add     al,bl                   ; calcula el color
	shl	al,2
        mov     [di],al                 ; lo graba en la paleta
        inc     di                      ; prximo dato de la paleta
        inc     si                      ; prximo valor del RGB
        dec     dx                      ; termin todos los valores RGB
        jnz     RGBLoop                 ;   no...

        sub     si,3                    ; vuelve al inicio del cjto de valores de RGB
	inc	cx
        cmp     cx,8                    ; termin los ocho valores de LUM ?
        jnz     BrilloLoop              ;   no...
        add     si,6                    ;   si, al prximo cjto RGB (color)
        inc     CuentaPaleta
        cmp     [CuentaPaleta],16       ; termin los 16 colores ?
        jnz     PaletaLoop             ;   no...
	
; continua con cosas de hardware

        mov     ah,1                    ; apaga el cursor
	mov	ch,020h
	int	010h
        mov     ah,0                    ; cambia a modo VGA 320x200
	mov	al,013h
	int	010h
        call    TIAPaleta
	ret

TIAModoTexto:
        mov     ah,0                    ; cambia a modo color 80x25
	mov	al,3
	int	010h
        mov     ah,1                    ; prende el cursor
	mov	cx,0B0Ch
	int	010h
	ret

; *****************************************************************************
;
;                        Configura la Paleta VGA
;
; *****************************************************************************

TIAPaleta:
        mov     bp,offset PCXPalette
        mov     cl,0
TIAPalLoop:
        mov     al,255
        mov     dx,03c6h
        out     dx,al
        add     dx,2
        mov     al,cl
        out     dx,al
        inc     dx
        mov     al,0[bp]
	shr	al,2
        out     dx,al
        mov     al,1[bp]
	shr	al,2
        out     dx,al
        mov     al,2[bp]
	shr	al,2
        out     dx,al
        add     bp,3
        inc     cl
        cmp     cl,128
        jne     TIAPalLoop
        ret

.CEND
.DATASEGMENT

; * vairables usadas en la generacin de la paleta

CuentaPaleta    dw      0

PCXPalette db 128*3 dup (0)     ; 384 -- la paleta generada viene aca

TablaPaletaDefault  db 0,   0,    0     ; 0 0 0 0 -- 0 (gris)
		db    63,  63,   63	; 0 0 0 0 -- 7

                db   15,   12,    5     ; 0 0 0 1 -- 0 (oro)
		db   63,   63,   50	; 0 0 0 1 -- 7

                db   25,   10,    5     ; 0 0 1 0 -- 0 (naranja)
		db   55,   55,   30	; 0 0 1 0 -- 7

                db   30,    5,    0     ; 0 0 1 1 -- 0 (naranja brillante)
		db   63,   55,   30	; 0 0 1 1 -- 7

                db   25,    5,    5     ; 0 1 0 0 -- 0 (rosa)
		db   63,   46,   47	; 0 1 0 0 -- 7 

                db   22,    8,   20     ; 0 1 0 1 -- 0 (prpura)
		db   63,   40,   63	; 0 1 0 1 -- 7 

                db   20,    8,   24     ; 0 1 1 0 -- 0 (prpura-azul)
		db   52,   40,   63	; 0 1 1 0 -- 7

                db   11,    8,   33     ; 0 1 1 1 -- 0 (azul <poco de prpura>)
                db   55,   48,   63     ; 0 1 1 1 -- 7

                db    8,    8,   35     ; 1 0 0 0 -- 0 (azul)
		db   45,   45,   63	; 1 0 0 0 -- 7

                db    6,    6,   25     ; 1 0 0 1 -- 0 (celeste)
		db   50,   50,   63	; 1 0 0 1 -- 7

                db    0,    8,   20     ; 1 0 1 0 -- 0 (turquesa)
		db   40,   55,   63	; 1 0 1 0 -- 7

                db    0,   12,    8     ; 1 0 1 1 -- 0 (verde-azul)
		db   40,   63,   55	; 1 0 1 1 -- 7

                db    4,   12,    4     ; 1 1 0 0 -- 0 (verde)
                db   50,   63,   50     ; 1 1 0 0 -- 7

                db   10,   15,    0     ; 1 1 0 1 -- 0 (amarillo-verde)
		db   50,   63,   35	; 1 1 0 1 -- 7

                db   15,   25,    0     ; 1 1 1 0 -- 0 (naranja-verde)
		db   55,   63,   30	; 1 1 1 0 -- 7

                db   20,   10,    0     ; 1 1 1 1 -- 0 (naranja suave)
		db   63,   50,   30	; 1 1 1 1 -- 7


.DEND
.CODESEGMENT
